#include "myWindow.h"
#include <windows.h>
#include <stdio.h>
#include "myWindowProc.h"
#include "jpegLoader.h"
#include "util.h"
#include "errHandle.h"

HBRUSH hBGBrush;

static HBITMAP hBitmap;

BackGround myBackGround;

void doDrawBackGround()
{
	HWND hwnd;
	char buf[256];
	HBRUSH hBrush;
	HDC hdc;
	int x, y;
	POINT point;
	RECT rect;
	hdc=GetWindowDC(myWindow.hGlobalWnd);

	hBGBrush=(HBRUSH)SelectObject(hdc, hBGBrush);
	//we need calculate the relative offset of clientarea to window
	clientAreaOrg(point);

	GetClientRect(myWindow.hGlobalWnd, &rect);
	
	//GetWindowOrgEx(hdc, &origin);
	//sprintf(buf, "[x=%d][y=%d][org=%d][org=%d]", x, y, origin.x, origin.y);
	//SetWindowText(myWindow.hGlobalWnd, buf);
	x=point.x;
	y=point.y;

	SetBrushOrgEx(hdc, x, y, &point);

	BitBlt(hdc, x, y, rect.right, rect.bottom, hdc, 0, 0, PATCOPY);
	//	0, 0, PATCOPY);
	
	SetBrushOrgEx(hdc, point.x, point.y, &point);

	hBGBrush=(HBRUSH)SelectObject(hdc, hBGBrush);
	ReleaseDC(myWindow.hGlobalWnd, hdc);
}

BackGround::BackGround()
{
	hBitmap=NULL;
	hBKDC=NULL;
}

void BackGround::init(HWND hwnd, bool addAlpha)
{
	HDC hdc;
	BITMAP bitmap;
	RECT rect;
	if (hwnd==NULL)
	{
		hwnd=myWindow.hGlobalWnd;
	}
	
	hdc=GetDC(hwnd);

	GetClientRect(hwnd, &rect);
	
	if (hBitmap==NULL)
	{
		SAFE_CALL((hBitmap=CreateCompatibleBitmap(hdc, rect.right, rect.bottom)), 
			"create background");
	}
	else
	{
		GetObject(hBitmap, sizeof(BITMAP), &bitmap);
		if (bitmap.bmWidth!=rect.right||bitmap.bmHeight!=rect.bottom)
		{
			DeleteObject(hBitmap);
			SAFE_CALL((hBitmap=CreateCompatibleBitmap(hdc, rect.right, rect.bottom)), 
				"create background");
		}
	}


	if (hBKDC==NULL)
	{
		SAFE_CALL((hBKDC=CreateCompatibleDC(hdc)), "create background DC");
	}
	//SAFE_CALL((hBrush=CreatePatternBrush(hBitmap)), "create background brush");
	
	SelectObject(hBKDC, hBitmap);	
	//SetBrushOrgEx(hBKDC, origin.x, origin.y, NULL);
	BitBlt(hBKDC, 0, 0, rect.right, rect.bottom, hdc, 0, 0, SRCCOPY);
	
	ReleaseDC(hwnd, hdc);
}

void BackGround::drawBackGround(RECT& region)
{
	HWND hwnd=myWindow.hGlobalWnd;
	HDC hdc;
	hdc=GetDC(hwnd);

	if (BitBlt(hdc, region.left, region.top, region.right-region.left,
		region.bottom-region.top, hBKDC, region.left, region.top, SRCCOPY)==0)
	{
		errHandle("what happend");
	}
	ReleaseDC(hwnd, hdc);
}


void BackGround::saveBackGround(RECT& region)
{
	HWND hwnd=myWindow.hGlobalWnd;
	HDC hdc;
	hdc=GetDC(hwnd);

	if (BitBlt(hBKDC, region.left, region.top, region.right-region.left,
		region.bottom-region.top, hdc, region.left, 
		region.top, SRCCOPY)==0)
	{
		errHandle("what is ");
	}
	ReleaseDC(hwnd, hdc);
}


BackGround::~BackGround()
{
	DeleteObject(hBitmap);
	DeleteDC(hBKDC);
}



long CALLBACK drawBackGround(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HBRUSH hOldBrush;
	BITMAP bitmap;
	HDC hdc;
	unsigned int result;
	MINMAXINFO* ptr;
	static RECT rect;
	HPEN hPen, hOldPen;
	int oldROP;
	POINT point;
	switch (message)
	{
	case WM_CREATE:

		hBitmap=(HBITMAP)LoadImage(NULL, "prettygirl.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		hdc=GetWindowDC(hwnd);

		//hBitmap=loadJPEGImage(hdc, "myBackground.jpg", bitmap);
		hBGBrush=CreatePatternBrush(hBitmap);
		
		clientAreaOrg(point, hwnd);
		GetObject(hBitmap, sizeof(BITMAP), &bitmap);
		
		SetBrushOrgEx(hdc, point.x, point.y, NULL);

		result=SetClassLong(hwnd, GCL_HBRBACKGROUND, (LONG)hBGBrush);
		
		ReleaseDC(hwnd, hdc);
		SetWindowPos(hwnd, HWND_TOP, 0, 0, bitmap.bmWidth+point.x*2, 
			bitmap.bmHeight+point.y+point.x, SWP_SHOWWINDOW);
		GetClientRect(hwnd, &rect);
		myBackGround.init(hwnd);
		
		break;
	case WM_RBUTTONDOWN:
		/*
		hdc=GetWindowDC(hwnd);
		GetClientRect(hwnd, &rect);
		
		hOldBrush=(HBRUSH)SelectObject(hdc, hBGBrush);
		point.x=point.y=0;
		//ClientToScreen(hwnd, &point);

		BitBlt(hdc, point.x, point.y, rect.right-rect.left, rect.bottom-rect.top, hdc,
			point.x, point.y, PATCOPY);
		SelectObject(hdc, hOldBrush);
		*/
		/*
		hPen=CreatePen(PS_SOLID, 20, RGB(255, 0, 0));
		hOldPen=(HPEN)SelectObject(hdc, hPen);
		oldROP=SetROP2(hdc, R2_MERGEPEN);
		MoveToEx(hdc, 0, 0, NULL);
		LineTo(hdc, 50, 50);
		SetROP2(hdc, oldROP);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPen);
		*/

		//ReleaseDC(hwnd, hdc);
		//doDrawBackGround();
		break;
	case WM_DESTROY:
		DeleteObject(hBitmap);
		DeleteObject(hBGBrush);
		break;
	}
	return 0L;
}

