#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "myWindow.h"

extern unsigned int rasterOp[256];

const int MaxDiskNumber=16;
const int MaxDiskRadius=50;
const int MaxDiskHalfHeight=20;
const int DiskWidthDelta=1;
const int DiskHeightDelta=1;
const int GroundLevelHeight=400;
const int MaxPegNumber=3;
const int MinPegLeft=100;
const int PegWidth=6;
const int PegHeight=150;

struct Peg
{
	int index;
	RECT rect;
};

struct Disk
{
	int index;
	int peg;
	RECT rect;
};


Disk diskArray[MaxDiskNumber];
Peg pegArray[MaxPegNumber];

void init()
{
	int height=0;
	int i;
	for (i=0; i<MaxPegNumber; i++)
	{
		pegArray[i].index=i;
		pegArray[i].rect.left=MinPegLeft;
		pegArray[i].rect.bottom=GroundLevelHeight;
		pegArray[i].rect.right=pegArray[i].rect.left+PegWidth;
		pegArray[i].rect.top=pegArray[i].rect.bottom-PegHeight;
	}

	for (i=0; i<MaxDiskNumber; i++)
	{
		diskArray[i].peg=0;
		diskArray[i].index=i;
		diskArray[i].rect.left=







long CALLBACK drawDisk(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hBitmap;
	static HDC hdcMem;
	static HBRUSH hBGBrush, hBitmapBrush;
	HBRUSH hOldBrush;
	HDC hdc;
	char buf[80];
	static BITMAP bitmap;
	static int startX=-1, startY=-1, endX, endY;
	int currentX, currentY, delta;
	RECT rect;
	static int index=0;
	const int Step=10;
	int length;
	switch (message)
	{
	case WM_CREATE:
		initDisk();
		hBitmap=(HBITMAP)LoadImage(myWindow.hGlobalInstance, "IDVIEW", IMAGE_BITMAP, 0, 0, 
			LR_DEFAULTCOLOR);		
		hdc=GetDC(hwnd);
		hBGBrush=(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND);
		
		hBitmapBrush=CreatePatternBrush(hBitmap);
		hdcMem=CreateCompatibleDC(hdc);
		SelectObject(hdcMem, hBitmap);

		SetTimer(hwnd, 1, 200, NULL);
		ReleaseDC(hwnd, hdc);
		break;
	case WM_TIMER:
		if (startX==-1||startY==-1|startX==endX&&startY==endY)
		{
			break;
		}
		length=(int)sqrt((endX-startX)*(endX-startX)+(endY-startY)*(endY-startY));
	
		if (Step>length)
		{
			delta=1;
		}
		else
		{
			delta=length/Step;
		}
		
		
		currentX=startX+(endX-startX)/delta;
		currentY=startY+(endY-startY)/delta;
		
		
		sprintf(buf, "length[%d]start[%d,%d]current[%d,%d]end[%d,%d]index[%d]", length, 
			startX, startY, currentX, currentY, endX, endY, index);
		SetWindowText(hwnd, buf);
		hdc=GetDC(hwnd);

		hOldBrush=(HBRUSH)SelectObject(hdc, hBrush);

		BitBlt(hdc, startX, startY, bitmap.bmWidth, bitmap.bmHeight, hdcMem, 0, 0,
			PATCOPY);
		rect.left=startX;
		rect.top=startY;
		rect.right=startX+Step;
		rect.bottom=startY+Step;
		//InvalidateRect(hwnd, &rect, TRUE);
		SelectObject(hdc, hBitmapBrush);
		
		BitBlt(hdc, currentX, currentY, bitmap.bmWidth, bitmap.bmHeight, hdcMem, 0, 0,
			rasterOp[index]);
		rect.left=currentX;
		rect.top=currentY;
		rect.right=currentX+Step;
		rect.bottom=currentY+Step;
		//InvalidateRect(hwnd, &rect, TRUE);


		startX=currentX;
		startY=currentY;
		SelectObject(hdc, hOldBrush);
		ReleaseDC(hwnd, hdc);
		
		break;
	case WM_LBUTTONDOWN:
		if (startX==-1||startY==-1)
		{
			startX=LOWORD(lParam)+Step;
			startY=HIWORD(lParam)+Step;
			index=0;			
		}
		else
		{
			index++;
			if (index==256)
			{
				index=0;
			}
		}
		hdc=GetDC(hwnd);
		hOldBrush=(HBRUSH)SelectObject(hdc, hBrush);
		BitBlt(hdc, startX, startY, bitmap.bmWidth, bitmap.bmHeight, hdcMem, 0, 0,
			0x00FC008A);
		SelectObject(hdc, hOldBrush);
		rect.left=startX;
		rect.top=startY;
		rect.right=startX+Step;
		rect.bottom=startY+Step;

		//InvalidateRect(hwnd, &rect, fa);
		endX=LOWORD(lParam);
		endY=HIWORD(lParam);
		sprintf(buf, "startx[%d]starty[%d]endx[%d]endy[%d]index[%d]", startX, startY, 
			endX, endY, index);
		
		SetWindowText(hwnd, buf);
		break;
	case WM_RBUTTONDOWN:
		index--;
		if (index<0)
		{
			index=0;
		}
		break;
	case WM_DESTROY:
		DeleteDC(hdcMem);
		DeleteObject(hBitmap);
		//DeleteObject(hBitmapBrush);
		KillTimer(hwnd, 1);
		break;
	}
	return 0L;
}



