#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "util.h"

#include "myWindow.h"
#include "sprite.h"
#include "errHandle.h"


char buf[256];

Sprite sprite;

Hex myHex;

HexRgn hexRgn;





bool getHexPoints(POINT hex, int size, POINT points[6])
{
	//POINT point;
	RECT rect;
	//clientAreaOrg(point);
	GetClientRect(myWindow.hGlobalWnd, &rect);
	for (int i=0; i<6; i++)
	{
		//points[i].x=size*myHex.Hexagon[i][0]+hex.x*myHex.offsetX+point.x;
		points[i].x=size*myHex.Hexagon[i][0]+hex.x*myHex.offsetX;
		if (hex.x%2==0)
		{
			points[i].y=size*myHex.Hexagon[i][1]+hex.y*myHex.offsetY;
		}
		else
		{
			points[i].y=size*myHex.Hexagon[i][1]+hex.y*myHex.offsetY+myHex.offsetY/2;
		}
		//points[i].y+=point.y;
		//if (points[i].y>rect.bottom+point.y||points[i].x>rect.right+point.x)
		if (points[i].y>rect.bottom||points[i].x>rect.right)
		{
			return false;
		}
	}
	return true;
}


void fillHexagon(POINT hex, COLORREF color)
{
	POINT points[6];
	HBRUSH hBrush;
	HDC hdc;

	if (getHexPoints(hex, myHex.size, points))
	{
		//hdc=GetWindowDC(myWindow.hGlobalWnd);
		hdc=GetDC(myWindow.hGlobalWnd);
		hBrush=CreateSolidBrush(color);
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		if (Polygon(hdc, points, 6)==0)
		{
			errHandle("what happen");
		}
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		DeleteObject(hBrush);
		ReleaseDC(myWindow.hGlobalWnd, hdc);
	}

}






void doDrawHexagon(int size, COLORREF color)
{
	bool isOutside=false;
	POINT points[7];
	HPEN hPen;
	HBRUSH hBrush;
	int width, height;
	HDC hdc;
	RECT rect;
	HWND hwnd;
	POINT origin, point, hex;
	hwnd=myWindow.hGlobalWnd;

	//hdc=GetWindowDC(hwnd);	
	hdc=GetDC(hwnd);	
	GetClientRect(hwnd, &rect);
	
	myHex.init(rect.right, rect.bottom, size);
	hPen=CreatePen(PS_SOLID, 3, color);
	hPen=(HPEN)SelectObject(hdc, hPen);
	
	//clientAreaOrg(point);

	for (int i=0; i<myHex.wStep; i++)
	{
		for (int j=0; j<myHex.hStep; j++)
		{
			/*
			isOutside=false;
			for (int k=0; k<6; k++)
			{
				points[k].x=size*Hexagon[k][0]+i*myHex.offsetX+point.x;
				if (i%2==0)
				{
					points[k].y=size*Hexagon[k][1]+j*myHex.offsetY;
				}
				else
				{
					points[k].y=size*Hexagon[k][1]+j*myHex.offsetY+myHex.offsetY/2;
				}
				points[k].y+=point.y;
				if (points[k].y>rect.bottom+point.y||points[k].x>rect.right+point.x)
				{
					isOutside=true;
					break;
				}
			}
			if (!isOutside)
			{
				Polygon(hdc, points, 6);
			}
			*/
			hex.x=i;
			hex.y=j;
			if (getHexPoints(hex, myHex.size, points))
			{
				memcpy(points+6, points, sizeof(POINT));
				Polyline(hdc, points, 7);
			}
		}
	}
	hPen=(HPEN)SelectObject(hdc, hPen);
	DeleteObject(hPen);
	ReleaseDC(hwnd, hdc);
}

/*
void doDrawHexagon(int size, COLORREF color)
{
	POINT points[6];
	HPEN hPen;
	HBRUSH hBrush;
	int width, height;
	HDC hdc;
	RECT rect;
	HWND hwnd;
	POINT origin, point;
	hwnd=myWindow.hGlobalWnd;

	hdc=GetWindowDC(hwnd);	
	GetWindowRect(hwnd, &rect);	
	
	width=(rect.right-rect.left)/(size*1.5);
	height=(rect.bottom-rect.top)/(size*1.732);
	hPen=CreatePen(PS_SOLID, 1, color);
	hPen=(HPEN)SelectObject(hdc, hPen);
	

	hBrush=(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND);
	hBrush=(HBRUSH)SelectObject(hdc, hBrush);
	clientAreaOrg(point);

	SetBrushOrgEx(hdc, point.x, point.y, &origin);

	for (int i=0; i<width; i++)
	{
		for (int j=0; j<height; j++)
		{
			for (int k=0; k<6; k++)
			{
				points[k].x=size*Hexagon[k][0]+i*size*1.5+point.x;
				if (i%2==0)
				{
					points[k].y=size*Hexagon[k][1]+j*size*1.732;
				}
				else
				{
					points[k].y=size*Hexagon[k][1]+(j+0.5)*size*1.732;
				}
				points[k].y+=point.y;
				
			}
			Polygon(hdc, points, 6);
		}
	}
	SetBrushOrgEx(hdc, point.x, point.y, &origin);
	hBrush=(HBRUSH)SelectObject(hdc, hBrush);
	hPen=(HPEN)SelectObject(hdc, hPen);
	DeleteObject(hPen);
	ReleaseDC(hwnd, hdc);
}
*/



long CALLBACK drawHexagon(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int x, y, result, offset;
	RECT rect;
	static POINT coord, hexCoord;
	static HBRUSH hRedBrush;
	HDC hdc, hMemDC;
	HBITMAP hBitmap;
	HMENU hMenu;
	static HRGN hRgn=NULL;
	BLENDFUNCTION blendFunc;
	
	
	switch(message)
	{
	case WM_CREATE:
		sprite.init(hwnd, "archer.bmp");
		hexRgn.init(hwnd, sprite.bitmap.bmWidth/2/0.612);
		//hRedBrush=Create
		//GetWindowRect(hwnd, &rect);
		//myHex.init(rect.right, rect.bottom, 32);
		//GetClientRect(hwnd, &rect);	
		//myHex.init(rect.right, rect.bottom, sprite.bitmap.bmWidth/2/0.612);
		break;

	case WM_LBUTTONDOWN:
		//hdc=GetDC(hwnd);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);	
		hRgn=hexRgn.getRgn(coord);

	
		
		//hMenu=GetSystemMenu(hwnd, FALSE);
		
		//DrawMenuBar(hwnd);





		break;
	case WM_RBUTTONDOWN:
		if (hRgn!=NULL)
		{
			hdc=GetDC(hwnd);
			GetRgnBox(hRgn, &rect);
			hMemDC=CreateCompatibleDC(hdc);
			hBitmap=CreateCompatibleBitmap(hdc, rect.right-rect.left, rect.bottom-rect.top);
			SelectObject(hMemDC, hBitmap);
			PatBlt(hMemDC, 0, 0, rect.right-rect.left, rect.bottom-rect.top, BLACKNESS);


			offset=20;
			blendFunc.BlendOp=AC_SRC_OVER;
			blendFunc.BlendFlags=0;
			blendFunc.SourceConstantAlpha=128;
			blendFunc.AlphaFormat=0;
			result=AlphaBlend(hdc, rect.left, rect.top, rect.right-rect.left, 
				rect.bottom-rect.top, hdc, rect.left+offset, rect.top+offset, 
				rect.right-rect.left, rect.bottom-rect.top, blendFunc);
			if (result==0)
			{
				errHandle("error");
			}
			//BitBlt(hdc, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top,
			//	hMemDC, 0, 0, SRCCOPY);
			//InvertRgn(hdc, hRgn);
			//hexRgn.hex.coord2hex(coord, hexCoord);
			//hexRgn.hex.hex2rect(hexCoord, rect);
			//sprite.drawSprite(hdc, rect, false);
			DeleteDC(hMemDC);
			DeleteObject(hBitmap);
			ReleaseDC(hwnd, hdc);
		}

	
		//AppendMenu(hMenu, 
	
	
		
		

		break;
	}
	return 0L;
}



/*
	doDrawHexagon(myHex.size, RGB(255, 32, 32));
		
		//clientAreaOrg(coord, hwnd);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);	
////debug
		//coord.x=390;
		//coord.y=247;
		//debug
		sprintf(buf, "[x=%d][y=%d]", coord.x, coord.y);

		
	
		if (myHex.coord2hex(coord, hex))
		{
		
			//sprintf(buf+strlen(buf), "[hex=%d][hex=%d]", hex.x, hex.y);
			//fillHexagon(hex, RGB(255, 0, 0));
			if (myHex.hex2rect(hex, rect))
			{
				//sprintf(buf, "[x=%d,y=%d][hex %d,%d][rect %d,%d]", coord.x, coord.y,
				//	hex.x, hex.y, rect.left, rect.top);
				SetWindowText(hwnd, buf);
				sprite.drawSprite(hwnd, rect.left, rect.top);
				//fillHexagon(hex, RGB(255, 0, 0));
			}
			
		}

		*/