#include <windows.h>
#include <stdio.h>
#include "myWindow.h"
#include "myWindowProc.h"
#include "transform.h"


long CALLBACK magnifier(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HRGN hRgn=NULL;
	static HBITMAP hBitmap=NULL;
	static HDC hMemDC=NULL;
	HDC hdc;
	const int Radius=70;
	const float Ratio=3.5;
	const int HalfWidth=Radius/Ratio;
	const int HalfHeight=Radius/Ratio;
	static POINT coord;
	
	static XFORM xForm, xForm1, xForm2;

	switch (message)
	{	
	case WM_MOUSEMOVE:			
	case WM_LBUTTONDOWN:
		
		hdc=GetDC(hwnd);

		if (hMemDC!=NULL)
		{
			ExtSelectClipRgn(hdc, hRgn, RGN_COPY);
			SetGraphicsMode(hdc, GM_ADVANCED);
			//SetWorldTransform(hdc, &xForm2);
			BitBlt(hdc, coord.x-Radius, coord.y-Radius, Radius*2, Radius*2, 
				hMemDC, 0, 0, SRCCOPY);
			DeleteObject(hRgn);


		}	
		else
		{
			hBitmap=CreateCompatibleBitmap(hdc, 2*Radius, 2*Radius);
			hMemDC=CreateCompatibleDC(hdc);
			SelectObject(hMemDC, hBitmap);
			scale(Ratio, Ratio, xForm1);
		}
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);	
		
		
		hRgn=CreateEllipticRgn(coord.x-Radius, coord.y-Radius, coord.x+Radius,
			coord.y+Radius);
		
	
		ExtSelectClipRgn(hdc, hRgn, RGN_COPY);
		
		
		BitBlt(hMemDC, 0, 0, Radius*2, Radius*2, hdc, coord.x-Radius, 
			coord.y-Radius, SRCCOPY);
		
		translate(coord.x, coord.y, xForm2);
		CombineTransform(&xForm, &xForm1, &xForm2);
		SetGraphicsMode(hdc, GM_ADVANCED);
		
		SetWorldTransform(hdc, &xForm);
		
		BitBlt(hdc, -Radius, -Radius, Radius*2, Radius*2, 
			hMemDC, 0, 0, SRCCOPY);
		identity(xForm);
		SetWorldTransform(hdc, &xForm);
		ExtSelectClipRgn(hdc, NULL, RGN_COPY);

		
		ReleaseDC(hwnd, hdc);	

		break;
	
	}


	return 0L;

}