#include <windows.h>
#include <vector>
#include <set>

const unsigned int PositionCount=8;

#define NW 0
#define N  1
#define NE 2
#define E  3
#define SE 4
#define S  5
#define SW 6
#define W  7

struct RectData
{
	RECT rect;
	RGBTRIPLE color;
};


struct PointComp
{
	bool operator()(const POINT& first, const POINT& second) const
	{
		return first.y<second.y||first.x<second.x&&first.y==second.y;
	}
};

struct RectDataComp
{
	bool operator()(const RectData& first, const RectData& second) const
	{
		return first.rect.top<second.rect.top||first.rect.top==second.rect.top&&
			first.rect.left<second.rect.left;
	}
};


struct RectComp
{
	bool operator()(const RECT& first, const RECT& second) const
	{
		/*
		return first.top<second.top||first.top==second.top&&first.left<second.left
			||first.top==second.top&&first.left==second.left&&first.bottom<second.bottom
			||first.top==second.top&&first.left==second.left&&first.bottom==second.bottom
			&&first.right<second.right;
			*/
		return first.left<second.left||first.left==second.left&&first.top<second.top;
	}
};







typedef unsigned char uchar;
typedef std::vector<HRGN> RgnVector;
typedef std::vector<POINT> PointVector;
typedef std::set<RECT, RectComp> RectSet;
typedef std::vector<RectData> RectDataVector;
//typedef std::vector<Segment> SegmentVector;




typedef std::set<RectData, RectDataComp> RectDataSet;
typedef std::vector<RECT> RectVector;

struct RegionData
{
	RGNDATAHEADER head;
	RGBTRIPLE color;
	RectSet rectSet;
};

struct RegionDataComp
{
	bool operator()(const RegionData& first, const RegionData& second) const
	{
		return memcmp(&first.color, &second.color, 3)<0;
		/*
		int colorCompResult;
		colorCompResult= memcmp(&first.color, &second.color, 3);
		if (colorCompResult<0)
		{
			return true;
		}
		else
		{
			if (colorCompResult>0)
			{
				return false;
			}
		}
		//same color, let's compare bounding box
		return RectComp(first.head.rcBound, second.head.rcBound);
		*/
	}
};

typedef std::multiset<RegionData, RegionDataComp> RegionDataSet;

typedef std::vector<RegionData> RegionDataVector;

typedef std::set<POINT, PointComp> PointSet;

void gridOp(long& x, long& y, int dir);

void analysis(HDC hdc, BITMAP& bitmap, uchar* pImage, RgnVector& rgnVector);

void displayRgn(HDC hdc, HRGN hRgn);

void drawRegionByIndex(HDC hdc, HRGN hRgn, int index);

void scanRegions(HDC hdc, BITMAP& bitmap, uchar* pImage, RgnVector& rgnVector);

HRGN transformRegion(HRGN hRgn, const XFORM* xForm);

int getRegionArea(HRGN hRgn);
