#pragma once
#include <windows.h>
#include "myWindow.h"


const int SpriteCount=4;
const int SpriteWidth=32*2;
const int SpriteHeight=32*2;

struct Sprite
{
	int x;
	int y;
	int w;
	int h;
	BITMAP bitmap;
	//static HDC hBKDC;
	HDC hBitmapDC, hMaskDC;
	HBITMAP hImageBitmap, hMaskBitmap;//, hBKBitmap;
	void init(HWND hwnd, char* name, bool fromFile=true);
	void draw(HDC hdc, int x, int y);
	void halfBright(HWND hwnd, int x, int y);
	void doubleBright(HWND hwnd, int x, int y);
	void drawSprite(HWND hwnd, int myX, int myY);
	void drawSprite(HDC hdc, const RECT& rect, bool eraseBkGround=true);
	void drawSprite(HDC hdc, int myX, int myY);
};



//by default it is 4 sprite
struct Animation
{
	static int timerID;
	int myTimerID;
	int x;
	int y;
	int oldX;
	int oldY;
	int w;
	int h;
	int index;
	unsigned int elapse;
	HBRUSH hBkBrush;
	MovementFuncType movement;
	Sprite sprite[SpriteCount];
	//Animation();
	virtual void drawAnimation(HWND hwnd, int myX, int myY, unsigned int elapseTime);
	
	void draw(HWND hwnd);
	void init(HWND hwnd, char*name, bool fromFile, bool jpeg=false);
};

void reDrawBackground(HDC hdc, int x, int y, int w, int h);

void drawSprite(HDC hdc, HDC hdcBitmap, HDC hMaskDC, int x, int y, int w, int h);

