#include <windows.h>

#define PI  3.14159
#define DEG2RAD(x) ((float)(x)/180.0*PI)



enum HEXENUM
{
	TopHex, TopRightHex, BottomRightHex, BottomHex, BottomLeftHex, TopLeftHex
};

struct Line
{
	float A;
	float B;
	float C;
	void init(POINT point, float w, float h);
	void init(POINT p1, POINT p2);
	Line(){}
	void point2line(POINT point, float& distance);
	void crossLine(Line& cross);
	void fixLine(POINT point);
	bool evalX(int& x, int y);
	bool evalY(int x, int& y);
};

struct Hex
{
	static float Hexagon[6][2];
	int width, height, size;
	int topFirst, leftFirst;
	int offsetX, offsetY;
	int wStep, hStep;
	int rectHalfSize;
	//POINT points[6];
	void init(int w, int h, int theSize);
	bool hex2rect(POINT hex, RECT& rect);
	bool coord2hex(POINT coord, POINT& hex);
	bool hex2coord(POINT hex, POINT& coord);//the rect top-left
	bool hex2center(POINT hex, POINT& center);
	void refresh();
	bool enumAroundHex(POINT hex, HEXENUM dir, POINT& result);
	void getHexPoints(POINT coord, POINT points[6]);
};


struct BackGround
{
	HBITMAP hBitmap;
	HDC hBKDC;
	BackGround();
	void init(HWND hwnd=NULL, bool addAlpha=false);
	void saveBackGround(RECT& region);
	void drawBackGround(RECT& region);
	~BackGround();
};

void fillHexagon(POINT hex, COLORREF color);
void doDrawHexagon(int size, COLORREF color);


//////////////////////////////////////////////
typedef void (*PrintMessageMethod)(char* msg);
void checkDisplay(PrintMessageMethod printMethod);

void drawSun(HWND hwnd, POINT coord, int radius, int lightLength, int lightNumber);

HBITMAP convertBM4Blending(HDC hdc, HBITMAP hBitmap);

struct HexRgn
{	
	HRGN* hexRgn;
	HRGN winRgn;
	Hex hex;
	void init(HWND hwnd, int size);
	HRGN getRgn(POINT hexCoord);
};

struct PNGINFO
{
	unsigned int width;//:              4 bytes
    unsigned int height;//:             4 byte
	unsigned char bitDepth;//          1 byte
	unsigned char colorType;//         1 byte
	unsigned char compressionMethod;//: 1 byte
	unsigned char filterMethod;//      1 byte
    unsigned char interlaceMethod;//   1 byte
};

const int PNG_offset=33;
struct PNGFILEINFO
{
	unsigned int imageOffset;
	unsigned int imageSize;
};


unsigned char* readImagePNG(BITMAPINFO& bitmapInfo, char* fileName);

void brightenRgn(HDC hdc, HRGN hRgn, float alpha);

void init(const BITMAP& bitmap, BITMAPINFOHEADER& bmHeader);

BOOL FileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName);
BOOL FileSaveDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName);